/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with builtin_expr_parse_ or builtin_expr_parse_, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with builtin_expr_parse__,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define builtin_expr_parse_BISON 1

/* Bison version.  */
#define builtin_expr_parse_BISON_VERSION "3.5"

/* Skeleton name.  */
#define builtin_expr_parse_SKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define builtin_expr_parse_PURE 0

/* Push parsers.  */
#define builtin_expr_parse_PUSH 0

/* Pull parsers.  */
#define builtin_expr_parse_PULL 1





# ifndef builtin_expr_parse__CAST
#  ifdef __cplusplus
#   define builtin_expr_parse__CAST(Type, Val) static_cast<Type> (Val)
#   define builtin_expr_parse__REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define builtin_expr_parse__CAST(Type, Val) ((Type) (Val))
#   define builtin_expr_parse__REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef builtin_expr_parse__NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define builtin_expr_parse__NULLPTR nullptr
#   else
#    define builtin_expr_parse__NULLPTR 0
#   endif
#  else
#   define builtin_expr_parse__NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef builtin_expr_parse_ERROR_VERBOSE
# undef builtin_expr_parse_ERROR_VERBOSE
# define builtin_expr_parse_ERROR_VERBOSE 1
#else
# define builtin_expr_parse_ERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef builtin_expr_parse__builtin_expr_parse__Y_TAB_H_INCLUDED
# define builtin_expr_parse__builtin_expr_parse__Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef builtin_expr_parse_DEBUG
# define builtin_expr_parse_DEBUG 0
#endif
#if builtin_expr_parse_DEBUG
extern int builtin_expr_parse_debug;
#endif

/* Token type.  */
#ifndef builtin_expr_parse_TOKENTYPE
# define builtin_expr_parse_TOKENTYPE
  enum builtin_expr_parse_tokentype
  {
    BIT_AND = 258,
    BIT_NOT = 259,
    BIT_OR = 260,
    BIT_XOR = 261,
    COLON = 262,
    DIV = 263,
    EQ = 264,
    GE = 265,
    GT = 266,
    JUNK = 267,
    LE = 268,
    LOGIC_AND = 269,
    LOGIC_NOT = 270,
    LOGIC_OR = 271,
    LP = 272,
    LT = 273,
    MINUS = 274,
    MOD = 275,
    MUL = 276,
    NE = 277,
    NUMBER = 278,
    PLUS = 279,
    QUEST = 280,
    RP = 281,
    SHIFT_L = 282,
    SHIFT_R = 283
  };
#endif
/* Tokens.  */
#define BIT_AND 258
#define BIT_NOT 259
#define BIT_OR 260
#define BIT_XOR 261
#define COLON 262
#define DIV 263
#define EQ 264
#define GE 265
#define GT 266
#define JUNK 267
#define LE 268
#define LOGIC_AND 269
#define LOGIC_NOT 270
#define LOGIC_OR 271
#define LP 272
#define LT 273
#define MINUS 274
#define MOD 275
#define MUL 276
#define NE 277
#define NUMBER 278
#define PLUS 279
#define QUEST 280
#define RP 281
#define SHIFT_L 282
#define SHIFT_R 283

/* Value type.  */
#if ! defined builtin_expr_parse_STYPE && ! defined builtin_expr_parse_STYPE_IS_DECLARED
union builtin_expr_parse_STYPE
{
#line 47 "cook/builtin/expr_parse.y"

        long    lv_integer;

#line 180 "y.tab.c"

};
typedef union builtin_expr_parse_STYPE builtin_expr_parse_STYPE;
# define builtin_expr_parse_STYPE_IS_TRIVIAL 1
# define builtin_expr_parse_STYPE_IS_DECLARED 1
#endif


extern builtin_expr_parse_STYPE builtin_expr_parse_lval;

int builtin_expr_parse_parse (void);

#endif /* !builtin_expr_parse__builtin_expr_parse__Y_TAB_H_INCLUDED  */

/* Second part of user prologue.  */
#line 67 "cook/builtin/expr_parse.y"


#include <common/ac/stdlib.h>

#include <cook/builtin/expr_lex.h>
#include <cook/builtin/expr_parse.h>
#include <cook/expr/position.h>
#include <common/str.h>
#include <common/str_list.h>
#include <common/sub.h>

static string_ty *result;


void
builtin_expr_parse_begin(const string_list_ty *args, const expr_position_ty *pp)
{
    builtin_expr_lex_open(args, pp);
    if (result)
    {
        str_free(result);
        result = 0;
    }
}


string_ty *
builtin_expr_parse_end(void)
{
    string_ty       *s;

    builtin_expr_lex_close();
    s = result;
    result = 0;
    if (!s)
        s = str_from_c("0");
    return s;
}

#line 236 "y.tab.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define builtin_expr_parse__STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ builtin_expr_parse_type_int8;
#elif defined builtin_expr_parse__STDINT_H
typedef int_least8_t builtin_expr_parse_type_int8;
#else
typedef signed char builtin_expr_parse_type_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ builtin_expr_parse_type_int16;
#elif defined builtin_expr_parse__STDINT_H
typedef int_least16_t builtin_expr_parse_type_int16;
#else
typedef short builtin_expr_parse_type_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ builtin_expr_parse_type_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined builtin_expr_parse__STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t builtin_expr_parse_type_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char builtin_expr_parse_type_uint8;
#else
typedef short builtin_expr_parse_type_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ builtin_expr_parse_type_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined builtin_expr_parse__STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t builtin_expr_parse_type_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short builtin_expr_parse_type_uint16;
#else
typedef int builtin_expr_parse_type_uint16;
#endif

#ifndef builtin_expr_parse_PTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define builtin_expr_parse_PTRDIFF_T __PTRDIFF_TYPE__
#  define builtin_expr_parse_PTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define builtin_expr_parse_PTRDIFF_T ptrdiff_t
#  define builtin_expr_parse_PTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define builtin_expr_parse_PTRDIFF_T long
#  define builtin_expr_parse_PTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef builtin_expr_parse_SIZE_T
# ifdef __SIZE_TYPE__
#  define builtin_expr_parse_SIZE_T __SIZE_TYPE__
# elif defined size_t
#  define builtin_expr_parse_SIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define builtin_expr_parse_SIZE_T size_t
# else
#  define builtin_expr_parse_SIZE_T unsigned
# endif
#endif

#define builtin_expr_parse_SIZE_MAXIMUM                                  \
  builtin_expr_parse__CAST (builtin_expr_parse_PTRDIFF_T,                                 \
           (builtin_expr_parse_PTRDIFF_MAXIMUM < builtin_expr_parse__CAST (builtin_expr_parse_SIZE_T, -1)  \
            ? builtin_expr_parse_PTRDIFF_MAXIMUM                         \
            : builtin_expr_parse__CAST (builtin_expr_parse_SIZE_T, -1)))

#define builtin_expr_parse_SIZEOF(X) builtin_expr_parse__CAST (builtin_expr_parse_PTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef builtin_expr_parse_type_int8 builtin_expr_parse__state_t;

/* State numbers in computations.  */
typedef int builtin_expr_parse__state_fast_t;

#ifndef builtin_expr_parse__
# if defined builtin_expr_parse_ENABLE_NLS && builtin_expr_parse_ENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define builtin_expr_parse__(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef builtin_expr_parse__
#  define builtin_expr_parse__(Msgid) Msgid
# endif
#endif

#ifndef builtin_expr_parse__ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define builtin_expr_parse__ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define builtin_expr_parse__ATTRIBUTE_PURE
# endif
#endif

#ifndef builtin_expr_parse__ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define builtin_expr_parse__ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define builtin_expr_parse__ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define builtin_expr_parse_USE(E) ((void) (E))
#else
# define builtin_expr_parse_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about builtin_expr_parse_lval being uninitialized.  */
# define builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define builtin_expr_parse__INITIAL_VALUE(Value) Value
#endif
#ifndef builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef builtin_expr_parse__INITIAL_VALUE
# define builtin_expr_parse__INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define builtin_expr_parse__IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define builtin_expr_parse__IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef builtin_expr_parse__IGNORE_USELESS_CAST_BEGIN
# define builtin_expr_parse__IGNORE_USELESS_CAST_BEGIN
# define builtin_expr_parse__IGNORE_USELESS_CAST_END
#endif


#define builtin_expr_parse__ASSERT(E) ((void) (0 && (E)))

#if ! defined builtin_expr_parse_overflow || builtin_expr_parse_ERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef builtin_expr_parse_STACK_USE_ALLOCA
#  if builtin_expr_parse_STACK_USE_ALLOCA
#   ifdef __GNUC__
#    define builtin_expr_parse_STACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define builtin_expr_parse_STACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define builtin_expr_parse_STACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef builtin_expr_parse_STACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define builtin_expr_parse_STACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef builtin_expr_parse_STACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define builtin_expr_parse_STACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define builtin_expr_parse_STACK_ALLOC builtin_expr_parse_MALLOC
#  define builtin_expr_parse_STACK_FREE builtin_expr_parse_FREE
#  ifndef builtin_expr_parse_STACK_ALLOC_MAXIMUM
#   define builtin_expr_parse_STACK_ALLOC_MAXIMUM builtin_expr_parse_SIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined builtin_expr_parse_MALLOC || defined malloc) \
             && (defined builtin_expr_parse_FREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef builtin_expr_parse_MALLOC
#   define builtin_expr_parse_MALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (builtin_expr_parse_SIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef builtin_expr_parse_FREE
#   define builtin_expr_parse_FREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined builtin_expr_parse_overflow || builtin_expr_parse_ERROR_VERBOSE */


#if (! defined builtin_expr_parse_overflow \
     && (! defined __cplusplus \
         || (defined builtin_expr_parse_STYPE_IS_TRIVIAL && builtin_expr_parse_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union builtin_expr_parse_alloc
{
  builtin_expr_parse__state_t builtin_expr_parse_ss_alloc;
  builtin_expr_parse_STYPE builtin_expr_parse_vs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define builtin_expr_parse_STACK_GAP_MAXIMUM (builtin_expr_parse_SIZEOF (union builtin_expr_parse_alloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define builtin_expr_parse_STACK_BYTES(N) \
     ((N) * (builtin_expr_parse_SIZEOF (builtin_expr_parse__state_t) + builtin_expr_parse_SIZEOF (builtin_expr_parse_STYPE)) \
      + builtin_expr_parse_STACK_GAP_MAXIMUM)

# define builtin_expr_parse_COPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables builtin_expr_parse_SIZE and builtin_expr_parse_STACKSIZE give the old and new number of
   elements in the stack, and builtin_expr_parse_PTR gives the new location of the
   stack.  Advance builtin_expr_parse_PTR to a properly aligned location for the next
   stack.  */
# define builtin_expr_parse_STACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        builtin_expr_parse_PTRDIFF_T builtin_expr_parse_newbytes;                                         \
        builtin_expr_parse_COPY (&builtin_expr_parse_ptr->Stack_alloc, Stack, builtin_expr_parse_size);                    \
        Stack = &builtin_expr_parse_ptr->Stack_alloc;                                    \
        builtin_expr_parse_newbytes = builtin_expr_parse_stacksize * builtin_expr_parse_SIZEOF (*Stack) + builtin_expr_parse_STACK_GAP_MAXIMUM; \
        builtin_expr_parse_ptr += builtin_expr_parse_newbytes / builtin_expr_parse_SIZEOF (*builtin_expr_parse_ptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined builtin_expr_parse_COPY_NEEDED && builtin_expr_parse_COPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef builtin_expr_parse_COPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define builtin_expr_parse_COPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, builtin_expr_parse__CAST (builtin_expr_parse_SIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define builtin_expr_parse_COPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          builtin_expr_parse_PTRDIFF_T builtin_expr_parse_i;                      \
          for (builtin_expr_parse_i = 0; builtin_expr_parse_i < (Count); builtin_expr_parse_i++)   \
            (Dst)[builtin_expr_parse_i] = (Src)[builtin_expr_parse_i];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !builtin_expr_parse_COPY_NEEDED */

/* builtin_expr_parse_FINAL -- State number of the termination state.  */
#define builtin_expr_parse_FINAL  14
/* builtin_expr_parse_LAST -- Last index in builtin_expr_parse_TABLE.  */
#define builtin_expr_parse_LAST   274

/* builtin_expr_parse_NTOKENS -- Number of terminals.  */
#define builtin_expr_parse_NTOKENS  29
/* builtin_expr_parse_NNTS -- Number of nonterminals.  */
#define builtin_expr_parse_NNTS  3
/* builtin_expr_parse_NRULES -- Number of rules.  */
#define builtin_expr_parse_NRULES  27
/* builtin_expr_parse_NSTATES -- Number of states.  */
#define builtin_expr_parse_NSTATES  56

#define builtin_expr_parse_UNDEFTOK  2
#define builtin_expr_parse_MAXUTOK   283


/* builtin_expr_parse_TRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by builtin_expr_parse_lex, with out-of-bounds checking.  */
#define builtin_expr_parse_TRANSLATE(builtin_expr_parse_X)                                                \
  (0 <= (builtin_expr_parse_X) && (builtin_expr_parse_X) <= builtin_expr_parse_MAXUTOK ? builtin_expr_parse_translate[builtin_expr_parse_X] : builtin_expr_parse_UNDEFTOK)

/* builtin_expr_parse_TRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by builtin_expr_parse_lex.  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_translate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28
};

#if builtin_expr_parse_DEBUG
  /* builtin_expr_parse_RLINE[builtin_expr_parse_N] -- Source line where rule number builtin_expr_parse_N was defined.  */
static const builtin_expr_parse_type_uint8 builtin_expr_parse_rline[] =
{
       0,   111,   111,   120,   122,   124,   127,   130,   132,   134,
     136,   146,   156,   158,   160,   162,   164,   166,   168,   170,
     172,   174,   176,   178,   180,   182,   184,   186
};
#endif

#if builtin_expr_parse_DEBUG || builtin_expr_parse_ERROR_VERBOSE || 0
/* builtin_expr_parse_TNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at builtin_expr_parse_NTOKENS, nonterminals.  */
static const char *const builtin_expr_parse_tname[] =
{
  "$end", "error", "$undefined", "BIT_AND", "BIT_NOT", "BIT_OR",
  "BIT_XOR", "COLON", "DIV", "EQ", "GE", "GT", "JUNK", "LE", "LOGIC_AND",
  "LOGIC_NOT", "LOGIC_OR", "LP", "LT", "MINUS", "MOD", "MUL", "NE",
  "NUMBER", "PLUS", "QUEST", "RP", "SHIFT_L", "SHIFT_R", "$accept", "main",
  "expr", builtin_expr_parse__NULLPTR
};
#endif

# ifdef builtin_expr_parse_PRINT
/* builtin_expr_parse_TOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const builtin_expr_parse_type_int16 builtin_expr_parse_toknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283
};
# endif

#define builtin_expr_parse_PACT_NINF (-2)

#define builtin_expr_parse_pact_value_is_default(builtin_expr_parse_n) \
  ((builtin_expr_parse_n) == builtin_expr_parse_PACT_NINF)

#define builtin_expr_parse_TABLE_NINF (-1)

#define builtin_expr_parse_table_value_is_error(builtin_expr_parse_n) \
  0

  /* builtin_expr_parse_PACT[STATE-NUM] -- Index in builtin_expr_parse_TABLE of the portion describing
     STATE-NUM.  */
static const builtin_expr_parse_type_int16 builtin_expr_parse_pact[] =
{
     249,   249,   249,   249,   249,    -2,   249,     4,    82,    -2,
      -2,    30,    -2,    -2,    -2,   249,   249,   249,   249,   249,
     249,   249,   249,   249,   249,   249,   249,   249,   249,   249,
     249,   249,   249,   249,    -2,   200,   157,   179,    -2,   221,
     235,   235,   235,   134,   108,   235,   104,    -2,    -2,   221,
     104,    56,   250,   250,   249,    82
};

  /* builtin_expr_parse_DEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when builtin_expr_parse_TABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_defact[] =
{
       0,     0,     0,     0,     0,     3,     0,     0,     2,     8,
       7,     0,     6,     5,     1,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     4,    22,    24,    23,    10,    20,
      19,    18,    17,    25,    26,    16,    13,    11,     9,    21,
      12,     0,    14,    15,     0,    27
};

  /* builtin_expr_parse_PGOTO[NTERM-NUM].  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_pgoto[] =
{
      -2,    -2,    -1
};

  /* builtin_expr_parse_DEFGOTO[NTERM-NUM].  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_defgoto[] =
{
      -1,     7,     8
};

  /* builtin_expr_parse_TABLE[builtin_expr_parse_PACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If builtin_expr_parse_TABLE_NINF, syntax error.  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_table[] =
{
       9,    10,    11,    12,    14,    13,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    15,     0,    16,    17,     0,    18,    19,
      20,    21,     0,    22,    23,     0,    24,     0,    25,    26,
      27,    28,    29,    55,    30,    31,    34,    32,    33,    15,
       0,    16,    17,    54,    18,    19,    20,    21,     0,    22,
      23,     0,    24,     0,    25,    26,    27,    28,    29,     0,
      30,    31,     0,    32,    33,    15,     0,    16,    17,     0,
      18,    19,    20,    21,     0,    22,    23,     0,    24,     0,
      25,    26,    27,    28,    29,     0,    30,    31,     0,    32,
      33,    15,    18,    16,    17,     0,    18,    19,    20,    21,
       0,    22,    23,     0,    27,    28,    25,    26,    27,    28,
      29,     0,    30,     0,     0,    32,    33,    15,     0,    16,
      17,     0,    18,    19,    20,    21,     0,    22,     0,     0,
       0,     0,    25,    26,    27,    28,    29,     0,    30,     0,
      15,    32,    33,    17,     0,    18,    19,    20,    21,     0,
      22,     0,     0,     0,     0,    25,    26,    27,    28,    29,
       0,    30,    15,     0,    32,    33,     0,    18,    19,    20,
      21,     0,    22,     0,     0,     0,     0,    25,    26,    27,
      28,    29,     0,    30,     0,     0,    32,    33,    18,    19,
      20,    21,     0,    22,     0,     0,     0,     0,    25,    26,
      27,    28,    29,     0,    30,     0,     0,    32,    33,    18,
       0,    20,    21,     0,    22,     0,     0,     0,     0,    25,
      26,    27,    28,    18,     0,    30,     0,     0,    32,    33,
       0,     0,     0,     1,    26,    27,    28,     0,    18,    30,
       0,     0,    32,    33,     2,     0,     3,     0,     4,    26,
      27,    28,     5,     6,    30
};

static const builtin_expr_parse_type_int8 builtin_expr_parse_check[] =
{
       1,     2,     3,     4,     0,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    -1,    13,    14,    -1,    16,    -1,    18,    19,
      20,    21,    22,    54,    24,    25,    26,    27,    28,     3,
      -1,     5,     6,     7,     8,     9,    10,    11,    -1,    13,
      14,    -1,    16,    -1,    18,    19,    20,    21,    22,    -1,
      24,    25,    -1,    27,    28,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    -1,    13,    14,    -1,    16,    -1,
      18,    19,    20,    21,    22,    -1,    24,    25,    -1,    27,
      28,     3,     8,     5,     6,    -1,     8,     9,    10,    11,
      -1,    13,    14,    -1,    20,    21,    18,    19,    20,    21,
      22,    -1,    24,    -1,    -1,    27,    28,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    -1,    13,    -1,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    -1,    24,    -1,
       3,    27,    28,     6,    -1,     8,     9,    10,    11,    -1,
      13,    -1,    -1,    -1,    -1,    18,    19,    20,    21,    22,
      -1,    24,     3,    -1,    27,    28,    -1,     8,     9,    10,
      11,    -1,    13,    -1,    -1,    -1,    -1,    18,    19,    20,
      21,    22,    -1,    24,    -1,    -1,    27,    28,     8,     9,
      10,    11,    -1,    13,    -1,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    -1,    24,    -1,    -1,    27,    28,     8,
      -1,    10,    11,    -1,    13,    -1,    -1,    -1,    -1,    18,
      19,    20,    21,     8,    -1,    24,    -1,    -1,    27,    28,
      -1,    -1,    -1,     4,    19,    20,    21,    -1,     8,    24,
      -1,    -1,    27,    28,    15,    -1,    17,    -1,    19,    19,
      20,    21,    23,    24,    24
};

  /* builtin_expr_parse_STOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_stos[] =
{
       0,     4,    15,    17,    19,    23,    24,    30,    31,    31,
      31,    31,    31,    31,     0,     3,     5,     6,     8,     9,
      10,    11,    13,    14,    16,    18,    19,    20,    21,    22,
      24,    25,    27,    28,    26,    31,    31,    31,    31,    31,
      31,    31,    31,    31,    31,    31,    31,    31,    31,    31,
      31,    31,    31,    31,     7,    31
};

  /* builtin_expr_parse_R1[builtin_expr_parse_N] -- Symbol number of symbol that rule builtin_expr_parse_N derives.  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_r1[] =
{
       0,    29,    30,    31,    31,    31,    31,    31,    31,    31,
      31,    31,    31,    31,    31,    31,    31,    31,    31,    31,
      31,    31,    31,    31,    31,    31,    31,    31
};

  /* builtin_expr_parse_R2[builtin_expr_parse_N] -- Number of symbols on the right hand side of rule builtin_expr_parse_N.  */
static const builtin_expr_parse_type_int8 builtin_expr_parse_r2[] =
{
       0,     2,     1,     1,     3,     2,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5
};


#define builtin_expr_parse_errok         (builtin_expr_parse_errstatus = 0)
#define builtin_expr_parse_clearin       (builtin_expr_parse_char = builtin_expr_parse_EMPTY)
#define builtin_expr_parse_EMPTY         (-2)
#define builtin_expr_parse_EOF           0

#define builtin_expr_parse_ACCEPT        goto builtin_expr_parse_acceptlab
#define builtin_expr_parse_ABORT         goto builtin_expr_parse_abortlab
#define builtin_expr_parse_ERROR         goto builtin_expr_parse_errorlab


#define builtin_expr_parse_RECOVERING()  (!!builtin_expr_parse_errstatus)

#define builtin_expr_parse_BACKUP(Token, Value)                                    \
  do                                                              \
    if (builtin_expr_parse_char == builtin_expr_parse_EMPTY)                                        \
      {                                                           \
        builtin_expr_parse_char = (Token);                                         \
        builtin_expr_parse_lval = (Value);                                         \
        builtin_expr_parse_POPSTACK (builtin_expr_parse_len);                                       \
        builtin_expr_parse_state = *builtin_expr_parse_ssp;                                         \
        goto builtin_expr_parse_backup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        builtin_expr_parse_error (builtin_expr_parse__("syntax error: cannot back up")); \
        builtin_expr_parse_ERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define builtin_expr_parse_TERROR        1
#define builtin_expr_parse_ERRCODE       256



/* Enable debugging if requested.  */
#if builtin_expr_parse_DEBUG

# ifndef builtin_expr_parse_FPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define builtin_expr_parse_FPRINTF fprintf
# endif

# define builtin_expr_parse_DPRINTF(Args)                        \
do {                                            \
  if (builtin_expr_parse_debug)                                  \
    builtin_expr_parse_FPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef builtin_expr_parse__LOCATION_PRINT
# define builtin_expr_parse__LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define builtin_expr_parse__SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (builtin_expr_parse_debug)                                                            \
    {                                                                     \
      builtin_expr_parse_FPRINTF (stderr, "%s ", Title);                                   \
      builtin_expr_parse__symbol_print (stderr,                                            \
                  Type, Value); \
      builtin_expr_parse_FPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on builtin_expr_parse_O.  |
`-----------------------------------*/

static void
builtin_expr_parse__symbol_value_print (FILE *builtin_expr_parse_o, int builtin_expr_parse_type, builtin_expr_parse_STYPE const * const builtin_expr_parse_valuep)
{
  FILE *builtin_expr_parse_output = builtin_expr_parse_o;
  builtin_expr_parse_USE (builtin_expr_parse_output);
  if (!builtin_expr_parse_valuep)
    return;
# ifdef builtin_expr_parse_PRINT
  if (builtin_expr_parse_type < builtin_expr_parse_NTOKENS)
    builtin_expr_parse_PRINT (builtin_expr_parse_o, builtin_expr_parse_toknum[builtin_expr_parse_type], *builtin_expr_parse_valuep);
# endif
  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  builtin_expr_parse_USE (builtin_expr_parse_type);
  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on builtin_expr_parse_O.  |
`---------------------------*/

static void
builtin_expr_parse__symbol_print (FILE *builtin_expr_parse_o, int builtin_expr_parse_type, builtin_expr_parse_STYPE const * const builtin_expr_parse_valuep)
{
  builtin_expr_parse_FPRINTF (builtin_expr_parse_o, "%s %s (",
             builtin_expr_parse_type < builtin_expr_parse_NTOKENS ? "token" : "nterm", builtin_expr_parse_tname[builtin_expr_parse_type]);

  builtin_expr_parse__symbol_value_print (builtin_expr_parse_o, builtin_expr_parse_type, builtin_expr_parse_valuep);
  builtin_expr_parse_FPRINTF (builtin_expr_parse_o, ")");
}

/*------------------------------------------------------------------.
| builtin_expr_parse__stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
builtin_expr_parse__stack_print (builtin_expr_parse__state_t *builtin_expr_parse_bottom, builtin_expr_parse__state_t *builtin_expr_parse_top)
{
  builtin_expr_parse_FPRINTF (stderr, "Stack now");
  for (; builtin_expr_parse_bottom <= builtin_expr_parse_top; builtin_expr_parse_bottom++)
    {
      int builtin_expr_parse_bot = *builtin_expr_parse_bottom;
      builtin_expr_parse_FPRINTF (stderr, " %d", builtin_expr_parse_bot);
    }
  builtin_expr_parse_FPRINTF (stderr, "\n");
}

# define builtin_expr_parse__STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (builtin_expr_parse_debug)                                                  \
    builtin_expr_parse__stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the builtin_expr_parse_RULE is going to be reduced.  |
`------------------------------------------------*/

static void
builtin_expr_parse__reduce_print (builtin_expr_parse__state_t *builtin_expr_parse_ssp, builtin_expr_parse_STYPE *builtin_expr_parse_vsp, int builtin_expr_parse_rule)
{
  int builtin_expr_parse_lno = builtin_expr_parse_rline[builtin_expr_parse_rule];
  int builtin_expr_parse_nrhs = builtin_expr_parse_r2[builtin_expr_parse_rule];
  int builtin_expr_parse_i;
  builtin_expr_parse_FPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             builtin_expr_parse_rule - 1, builtin_expr_parse_lno);
  /* The symbols being reduced.  */
  for (builtin_expr_parse_i = 0; builtin_expr_parse_i < builtin_expr_parse_nrhs; builtin_expr_parse_i++)
    {
      builtin_expr_parse_FPRINTF (stderr, "   $%d = ", builtin_expr_parse_i + 1);
      builtin_expr_parse__symbol_print (stderr,
                       builtin_expr_parse_stos[builtin_expr_parse_ssp[builtin_expr_parse_i + 1 - builtin_expr_parse_nrhs]],
                       &builtin_expr_parse_vsp[(builtin_expr_parse_i + 1) - (builtin_expr_parse_nrhs)]
                                              );
      builtin_expr_parse_FPRINTF (stderr, "\n");
    }
}

# define builtin_expr_parse__REDUCE_PRINT(Rule)          \
do {                                    \
  if (builtin_expr_parse_debug)                          \
    builtin_expr_parse__reduce_print (builtin_expr_parse_ssp, builtin_expr_parse_vsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int builtin_expr_parse_debug;
#else /* !builtin_expr_parse_DEBUG */
# define builtin_expr_parse_DPRINTF(Args)
# define builtin_expr_parse__SYMBOL_PRINT(Title, Type, Value, Location)
# define builtin_expr_parse__STACK_PRINT(Bottom, Top)
# define builtin_expr_parse__REDUCE_PRINT(Rule)
#endif /* !builtin_expr_parse_DEBUG */


/* builtin_expr_parse_INITDEPTH -- initial size of the parser's stacks.  */
#ifndef builtin_expr_parse_INITDEPTH
# define builtin_expr_parse_INITDEPTH 200
#endif

/* builtin_expr_parse_MAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   builtin_expr_parse_STACK_ALLOC_MAXIMUM < builtin_expr_parse_STACK_BYTES (builtin_expr_parse_MAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef builtin_expr_parse_MAXDEPTH
# define builtin_expr_parse_MAXDEPTH 10000
#endif


#if builtin_expr_parse_ERROR_VERBOSE

# ifndef builtin_expr_parse_strlen
#  if defined __GLIBC__ && defined _STRING_H
#   define builtin_expr_parse_strlen(S) (builtin_expr_parse__CAST (builtin_expr_parse_PTRDIFF_T, strlen (S)))
#  else
/* Return the length of builtin_expr_parse_STR.  */
static builtin_expr_parse_PTRDIFF_T
builtin_expr_parse_strlen (const char *builtin_expr_parse_str)
{
  builtin_expr_parse_PTRDIFF_T builtin_expr_parse_len;
  for (builtin_expr_parse_len = 0; builtin_expr_parse_str[builtin_expr_parse_len]; builtin_expr_parse_len++)
    continue;
  return builtin_expr_parse_len;
}
#  endif
# endif

# ifndef builtin_expr_parse_stpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define builtin_expr_parse_stpcpy stpcpy
#  else
/* Copy builtin_expr_parse_SRC to builtin_expr_parse_DEST, returning the address of the terminating '\0' in
   builtin_expr_parse_DEST.  */
static char *
builtin_expr_parse_stpcpy (char *builtin_expr_parse_dest, const char *builtin_expr_parse_src)
{
  char *builtin_expr_parse_d = builtin_expr_parse_dest;
  const char *builtin_expr_parse_s = builtin_expr_parse_src;

  while ((*builtin_expr_parse_d++ = *builtin_expr_parse_s++) != '\0')
    continue;

  return builtin_expr_parse_d - 1;
}
#  endif
# endif

# ifndef builtin_expr_parse_tnamerr
/* Copy to builtin_expr_parse_RES the contents of builtin_expr_parse_STR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for builtin_expr_parse_error.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  builtin_expr_parse_STR is taken from builtin_expr_parse_tname.  If builtin_expr_parse_RES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static builtin_expr_parse_PTRDIFF_T
builtin_expr_parse_tnamerr (char *builtin_expr_parse_res, const char *builtin_expr_parse_str)
{
  if (*builtin_expr_parse_str == '"')
    {
      builtin_expr_parse_PTRDIFF_T builtin_expr_parse_n = 0;
      char const *builtin_expr_parse_p = builtin_expr_parse_str;

      for (;;)
        switch (*++builtin_expr_parse_p)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++builtin_expr_parse_p != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (builtin_expr_parse_res)
              builtin_expr_parse_res[builtin_expr_parse_n] = *builtin_expr_parse_p;
            builtin_expr_parse_n++;
            break;

          case '"':
            if (builtin_expr_parse_res)
              builtin_expr_parse_res[builtin_expr_parse_n] = '\0';
            return builtin_expr_parse_n;
          }
    do_not_strip_quotes: ;
    }

  if (builtin_expr_parse_res)
    return builtin_expr_parse_stpcpy (builtin_expr_parse_res, builtin_expr_parse_str) - builtin_expr_parse_res;
  else
    return builtin_expr_parse_strlen (builtin_expr_parse_str);
}
# endif

/* Copy into *builtin_expr_parse_MSG, which is of size *builtin_expr_parse_MSG_ALLOC, an error message
   about the unexpected token builtin_expr_parse_TOKEN for the state stack whose top is
   builtin_expr_parse_SSP.

   Return 0 if *builtin_expr_parse_MSG was successfully written.  Return 1 if *builtin_expr_parse_MSG is
   not large enough to hold the message.  In that case, also set
   *builtin_expr_parse_MSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
builtin_expr_parse_syntax_error (builtin_expr_parse_PTRDIFF_T *builtin_expr_parse_msg_alloc, char **builtin_expr_parse_msg,
                builtin_expr_parse__state_t *builtin_expr_parse_ssp, int builtin_expr_parse_token)
{
  enum { builtin_expr_parse_ERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *builtin_expr_parse_format = builtin_expr_parse__NULLPTR;
  /* Arguments of builtin_expr_parse_format: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *builtin_expr_parse_arg[builtin_expr_parse_ERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of builtin_expr_parse_ARG. */
  int builtin_expr_parse_count = 0;
  /* Cumulated lengths of builtin_expr_parse_ARG.  */
  builtin_expr_parse_PTRDIFF_T builtin_expr_parse_size = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in builtin_expr_parse_char) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated builtin_expr_parse_char.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (builtin_expr_parse_token != builtin_expr_parse_EMPTY)
    {
      int builtin_expr_parse_n = builtin_expr_parse_pact[*builtin_expr_parse_ssp];
      builtin_expr_parse_PTRDIFF_T builtin_expr_parse_size0 = builtin_expr_parse_tnamerr (builtin_expr_parse__NULLPTR, builtin_expr_parse_tname[builtin_expr_parse_token]);
      builtin_expr_parse_size = builtin_expr_parse_size0;
      builtin_expr_parse_arg[builtin_expr_parse_count++] = builtin_expr_parse_tname[builtin_expr_parse_token];
      if (!builtin_expr_parse_pact_value_is_default (builtin_expr_parse_n))
        {
          /* Start builtin_expr_parse_X at -builtin_expr_parse_N if negative to avoid negative indexes in
             builtin_expr_parse_CHECK.  In other words, skip the first -builtin_expr_parse_N actions for
             this state because they are default actions.  */
          int builtin_expr_parse_xbegin = builtin_expr_parse_n < 0 ? -builtin_expr_parse_n : 0;
          /* Stay within bounds of both builtin_expr_parse_check and builtin_expr_parse_tname.  */
          int builtin_expr_parse_checklim = builtin_expr_parse_LAST - builtin_expr_parse_n + 1;
          int builtin_expr_parse_xend = builtin_expr_parse_checklim < builtin_expr_parse_NTOKENS ? builtin_expr_parse_checklim : builtin_expr_parse_NTOKENS;
          int builtin_expr_parse_x;

          for (builtin_expr_parse_x = builtin_expr_parse_xbegin; builtin_expr_parse_x < builtin_expr_parse_xend; ++builtin_expr_parse_x)
            if (builtin_expr_parse_check[builtin_expr_parse_x + builtin_expr_parse_n] == builtin_expr_parse_x && builtin_expr_parse_x != builtin_expr_parse_TERROR
                && !builtin_expr_parse_table_value_is_error (builtin_expr_parse_table[builtin_expr_parse_x + builtin_expr_parse_n]))
              {
                if (builtin_expr_parse_count == builtin_expr_parse_ERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    builtin_expr_parse_count = 1;
                    builtin_expr_parse_size = builtin_expr_parse_size0;
                    break;
                  }
                builtin_expr_parse_arg[builtin_expr_parse_count++] = builtin_expr_parse_tname[builtin_expr_parse_x];
                {
                  builtin_expr_parse_PTRDIFF_T builtin_expr_parse_size1
                    = builtin_expr_parse_size + builtin_expr_parse_tnamerr (builtin_expr_parse__NULLPTR, builtin_expr_parse_tname[builtin_expr_parse_x]);
                  if (builtin_expr_parse_size <= builtin_expr_parse_size1 && builtin_expr_parse_size1 <= builtin_expr_parse_STACK_ALLOC_MAXIMUM)
                    builtin_expr_parse_size = builtin_expr_parse_size1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (builtin_expr_parse_count)
    {
# define builtin_expr_parse_CASE_(N, S)                      \
      case N:                               \
        builtin_expr_parse_format = S;                       \
      break
    default: /* Avoid compiler warnings. */
      builtin_expr_parse_CASE_(0, builtin_expr_parse__("syntax error"));
      builtin_expr_parse_CASE_(1, builtin_expr_parse__("syntax error, unexpected %s"));
      builtin_expr_parse_CASE_(2, builtin_expr_parse__("syntax error, unexpected %s, expecting %s"));
      builtin_expr_parse_CASE_(3, builtin_expr_parse__("syntax error, unexpected %s, expecting %s or %s"));
      builtin_expr_parse_CASE_(4, builtin_expr_parse__("syntax error, unexpected %s, expecting %s or %s or %s"));
      builtin_expr_parse_CASE_(5, builtin_expr_parse__("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef builtin_expr_parse_CASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    builtin_expr_parse_PTRDIFF_T builtin_expr_parse_size1 = builtin_expr_parse_size + (builtin_expr_parse_strlen (builtin_expr_parse_format) - 2 * builtin_expr_parse_count) + 1;
    if (builtin_expr_parse_size <= builtin_expr_parse_size1 && builtin_expr_parse_size1 <= builtin_expr_parse_STACK_ALLOC_MAXIMUM)
      builtin_expr_parse_size = builtin_expr_parse_size1;
    else
      return 2;
  }

  if (*builtin_expr_parse_msg_alloc < builtin_expr_parse_size)
    {
      *builtin_expr_parse_msg_alloc = 2 * builtin_expr_parse_size;
      if (! (builtin_expr_parse_size <= *builtin_expr_parse_msg_alloc
             && *builtin_expr_parse_msg_alloc <= builtin_expr_parse_STACK_ALLOC_MAXIMUM))
        *builtin_expr_parse_msg_alloc = builtin_expr_parse_STACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *builtin_expr_parse_p = *builtin_expr_parse_msg;
    int builtin_expr_parse_i = 0;
    while ((*builtin_expr_parse_p = *builtin_expr_parse_format) != '\0')
      if (*builtin_expr_parse_p == '%' && builtin_expr_parse_format[1] == 's' && builtin_expr_parse_i < builtin_expr_parse_count)
        {
          builtin_expr_parse_p += builtin_expr_parse_tnamerr (builtin_expr_parse_p, builtin_expr_parse_arg[builtin_expr_parse_i++]);
          builtin_expr_parse_format += 2;
        }
      else
        {
          ++builtin_expr_parse_p;
          ++builtin_expr_parse_format;
        }
  }
  return 0;
}
#endif /* builtin_expr_parse_ERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
builtin_expr_parse_destruct (const char *builtin_expr_parse_msg, int builtin_expr_parse_type, builtin_expr_parse_STYPE *builtin_expr_parse_valuep)
{
  builtin_expr_parse_USE (builtin_expr_parse_valuep);
  if (!builtin_expr_parse_msg)
    builtin_expr_parse_msg = "Deleting";
  builtin_expr_parse__SYMBOL_PRINT (builtin_expr_parse_msg, builtin_expr_parse_type, builtin_expr_parse_valuep, builtin_expr_parse_locationp);

  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  builtin_expr_parse_USE (builtin_expr_parse_type);
  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int builtin_expr_parse_char;

/* The semantic value of the lookahead symbol.  */
builtin_expr_parse_STYPE builtin_expr_parse_lval;
/* Number of syntax errors so far.  */
int builtin_expr_parse_nerrs;


/*----------.
| builtin_expr_parse_parse.  |
`----------*/

int
builtin_expr_parse_parse (void)
{
    builtin_expr_parse__state_fast_t builtin_expr_parse_state;
    /* Number of tokens to shift before error messages enabled.  */
    int builtin_expr_parse_errstatus;

    /* The stacks and their tools:
       'builtin_expr_parse_ss': related to states.
       'builtin_expr_parse_vs': related to semantic values.

       Refer to the stacks through separate pointers, to allow builtin_expr_parse_overflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    builtin_expr_parse__state_t builtin_expr_parse_ssa[builtin_expr_parse_INITDEPTH];
    builtin_expr_parse__state_t *builtin_expr_parse_ss;
    builtin_expr_parse__state_t *builtin_expr_parse_ssp;

    /* The semantic value stack.  */
    builtin_expr_parse_STYPE builtin_expr_parse_vsa[builtin_expr_parse_INITDEPTH];
    builtin_expr_parse_STYPE *builtin_expr_parse_vs;
    builtin_expr_parse_STYPE *builtin_expr_parse_vsp;

    builtin_expr_parse_PTRDIFF_T builtin_expr_parse_stacksize;

  int builtin_expr_parse_n;
  int builtin_expr_parse_result;
  /* Lookahead token as an internal (translated) token number.  */
  int builtin_expr_parse_token = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  builtin_expr_parse_STYPE builtin_expr_parse_val;

#if builtin_expr_parse_ERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char builtin_expr_parse_msgbuf[128];
  char *builtin_expr_parse_msg = builtin_expr_parse_msgbuf;
  builtin_expr_parse_PTRDIFF_T builtin_expr_parse_msg_alloc = sizeof builtin_expr_parse_msgbuf;
#endif

#define builtin_expr_parse_POPSTACK(N)   (builtin_expr_parse_vsp -= (N), builtin_expr_parse_ssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int builtin_expr_parse_len = 0;

  builtin_expr_parse_ssp = builtin_expr_parse_ss = builtin_expr_parse_ssa;
  builtin_expr_parse_vsp = builtin_expr_parse_vs = builtin_expr_parse_vsa;
  builtin_expr_parse_stacksize = builtin_expr_parse_INITDEPTH;

  builtin_expr_parse_DPRINTF ((stderr, "Starting parse\n"));

  builtin_expr_parse_state = 0;
  builtin_expr_parse_errstatus = 0;
  builtin_expr_parse_nerrs = 0;
  builtin_expr_parse_char = builtin_expr_parse_EMPTY; /* Cause a token to be read.  */
  goto builtin_expr_parse_setstate;


/*------------------------------------------------------------.
| builtin_expr_parse_newstate -- push a new state, which is found in builtin_expr_parse_state.  |
`------------------------------------------------------------*/
builtin_expr_parse_newstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  builtin_expr_parse_ssp++;


/*--------------------------------------------------------------------.
| builtin_expr_parse_setstate -- set current state (the top of the stack) to builtin_expr_parse_state.  |
`--------------------------------------------------------------------*/
builtin_expr_parse_setstate:
  builtin_expr_parse_DPRINTF ((stderr, "Entering state %d\n", builtin_expr_parse_state));
  builtin_expr_parse__ASSERT (0 <= builtin_expr_parse_state && builtin_expr_parse_state < builtin_expr_parse_NSTATES);
  builtin_expr_parse__IGNORE_USELESS_CAST_BEGIN
  *builtin_expr_parse_ssp = builtin_expr_parse__CAST (builtin_expr_parse__state_t, builtin_expr_parse_state);
  builtin_expr_parse__IGNORE_USELESS_CAST_END

  if (builtin_expr_parse_ss + builtin_expr_parse_stacksize - 1 <= builtin_expr_parse_ssp)
#if !defined builtin_expr_parse_overflow && !defined builtin_expr_parse_STACK_RELOCATE
    goto builtin_expr_parse_exhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      builtin_expr_parse_PTRDIFF_T builtin_expr_parse_size = builtin_expr_parse_ssp - builtin_expr_parse_ss + 1;

# if defined builtin_expr_parse_overflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        builtin_expr_parse__state_t *builtin_expr_parse_ss1 = builtin_expr_parse_ss;
        builtin_expr_parse_STYPE *builtin_expr_parse_vs1 = builtin_expr_parse_vs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if builtin_expr_parse_overflow is a macro.  */
        builtin_expr_parse_overflow (builtin_expr_parse__("memory exhausted"),
                    &builtin_expr_parse_ss1, builtin_expr_parse_size * builtin_expr_parse_SIZEOF (*builtin_expr_parse_ssp),
                    &builtin_expr_parse_vs1, builtin_expr_parse_size * builtin_expr_parse_SIZEOF (*builtin_expr_parse_vsp),
                    &builtin_expr_parse_stacksize);
        builtin_expr_parse_ss = builtin_expr_parse_ss1;
        builtin_expr_parse_vs = builtin_expr_parse_vs1;
      }
# else /* defined builtin_expr_parse_STACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (builtin_expr_parse_MAXDEPTH <= builtin_expr_parse_stacksize)
        goto builtin_expr_parse_exhaustedlab;
      builtin_expr_parse_stacksize *= 2;
      if (builtin_expr_parse_MAXDEPTH < builtin_expr_parse_stacksize)
        builtin_expr_parse_stacksize = builtin_expr_parse_MAXDEPTH;

      {
        builtin_expr_parse__state_t *builtin_expr_parse_ss1 = builtin_expr_parse_ss;
        union builtin_expr_parse_alloc *builtin_expr_parse_ptr =
          builtin_expr_parse__CAST (union builtin_expr_parse_alloc *,
                   builtin_expr_parse_STACK_ALLOC (builtin_expr_parse__CAST (builtin_expr_parse_SIZE_T, builtin_expr_parse_STACK_BYTES (builtin_expr_parse_stacksize))));
        if (! builtin_expr_parse_ptr)
          goto builtin_expr_parse_exhaustedlab;
        builtin_expr_parse_STACK_RELOCATE (builtin_expr_parse_ss_alloc, builtin_expr_parse_ss);
        builtin_expr_parse_STACK_RELOCATE (builtin_expr_parse_vs_alloc, builtin_expr_parse_vs);
# undef builtin_expr_parse_STACK_RELOCATE
        if (builtin_expr_parse_ss1 != builtin_expr_parse_ssa)
          builtin_expr_parse_STACK_FREE (builtin_expr_parse_ss1);
      }
# endif

      builtin_expr_parse_ssp = builtin_expr_parse_ss + builtin_expr_parse_size - 1;
      builtin_expr_parse_vsp = builtin_expr_parse_vs + builtin_expr_parse_size - 1;

      builtin_expr_parse__IGNORE_USELESS_CAST_BEGIN
      builtin_expr_parse_DPRINTF ((stderr, "Stack size increased to %ld\n",
                  builtin_expr_parse__CAST (long, builtin_expr_parse_stacksize)));
      builtin_expr_parse__IGNORE_USELESS_CAST_END

      if (builtin_expr_parse_ss + builtin_expr_parse_stacksize - 1 <= builtin_expr_parse_ssp)
        builtin_expr_parse_ABORT;
    }
#endif /* !defined builtin_expr_parse_overflow && !defined builtin_expr_parse_STACK_RELOCATE */

  if (builtin_expr_parse_state == builtin_expr_parse_FINAL)
    builtin_expr_parse_ACCEPT;

  goto builtin_expr_parse_backup;


/*-----------.
| builtin_expr_parse_backup.  |
`-----------*/
builtin_expr_parse_backup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  builtin_expr_parse_n = builtin_expr_parse_pact[builtin_expr_parse_state];
  if (builtin_expr_parse_pact_value_is_default (builtin_expr_parse_n))
    goto builtin_expr_parse_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* builtin_expr_parse_CHAR is either builtin_expr_parse_EMPTY or builtin_expr_parse_EOF or a valid lookahead symbol.  */
  if (builtin_expr_parse_char == builtin_expr_parse_EMPTY)
    {
      builtin_expr_parse_DPRINTF ((stderr, "Reading a token: "));
      builtin_expr_parse_char = builtin_expr_parse_lex ();
    }

  if (builtin_expr_parse_char <= builtin_expr_parse_EOF)
    {
      builtin_expr_parse_char = builtin_expr_parse_token = builtin_expr_parse_EOF;
      builtin_expr_parse_DPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      builtin_expr_parse_token = builtin_expr_parse_TRANSLATE (builtin_expr_parse_char);
      builtin_expr_parse__SYMBOL_PRINT ("Next token is", builtin_expr_parse_token, &builtin_expr_parse_lval, &builtin_expr_parse_lloc);
    }

  /* If the proper action on seeing token builtin_expr_parse_TOKEN is to reduce or to
     detect an error, take that action.  */
  builtin_expr_parse_n += builtin_expr_parse_token;
  if (builtin_expr_parse_n < 0 || builtin_expr_parse_LAST < builtin_expr_parse_n || builtin_expr_parse_check[builtin_expr_parse_n] != builtin_expr_parse_token)
    goto builtin_expr_parse_default;
  builtin_expr_parse_n = builtin_expr_parse_table[builtin_expr_parse_n];
  if (builtin_expr_parse_n <= 0)
    {
      if (builtin_expr_parse_table_value_is_error (builtin_expr_parse_n))
        goto builtin_expr_parse_errlab;
      builtin_expr_parse_n = -builtin_expr_parse_n;
      goto builtin_expr_parse_reduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (builtin_expr_parse_errstatus)
    builtin_expr_parse_errstatus--;

  /* Shift the lookahead token.  */
  builtin_expr_parse__SYMBOL_PRINT ("Shifting", builtin_expr_parse_token, &builtin_expr_parse_lval, &builtin_expr_parse_lloc);
  builtin_expr_parse_state = builtin_expr_parse_n;
  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++builtin_expr_parse_vsp = builtin_expr_parse_lval;
  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  builtin_expr_parse_char = builtin_expr_parse_EMPTY;
  goto builtin_expr_parse_newstate;


/*-----------------------------------------------------------.
| builtin_expr_parse_default -- do the default action for the current state.  |
`-----------------------------------------------------------*/
builtin_expr_parse_default:
  builtin_expr_parse_n = builtin_expr_parse_defact[builtin_expr_parse_state];
  if (builtin_expr_parse_n == 0)
    goto builtin_expr_parse_errlab;
  goto builtin_expr_parse_reduce;


/*-----------------------------.
| builtin_expr_parse_reduce -- do a reduction.  |
`-----------------------------*/
builtin_expr_parse_reduce:
  /* builtin_expr_parse_n is the number of a rule to reduce with.  */
  builtin_expr_parse_len = builtin_expr_parse_r2[builtin_expr_parse_n];

  /* If builtin_expr_parse_LEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets builtin_expr_parse_VAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to builtin_expr_parse_VAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that builtin_expr_parse_VAL may be used uninitialized.  */
  builtin_expr_parse_val = builtin_expr_parse_vsp[1-builtin_expr_parse_len];


  builtin_expr_parse__REDUCE_PRINT (builtin_expr_parse_n);
  switch (builtin_expr_parse_n)
    {
  case 2:
#line 112 "cook/builtin/expr_parse.y"
        {
            if (builtin_expr_lex_error_count() != 0)
                builtin_expr_parse_ABORT;
            result = str_format("%ld", (builtin_expr_parse_vsp[0].lv_integer));
        }
#line 1471 "y.tab.c"
    break;

  case 3:
#line 121 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[0].lv_integer); }
#line 1477 "y.tab.c"
    break;

  case 4:
#line 123 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-1].lv_integer); }
#line 1483 "y.tab.c"
    break;

  case 5:
#line 126 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[0].lv_integer); }
#line 1489 "y.tab.c"
    break;

  case 6:
#line 129 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = -(builtin_expr_parse_vsp[0].lv_integer); }
#line 1495 "y.tab.c"
    break;

  case 7:
#line 131 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = !(builtin_expr_parse_vsp[0].lv_integer); }
#line 1501 "y.tab.c"
    break;

  case 8:
#line 133 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ~(builtin_expr_parse_vsp[0].lv_integer); }
#line 1507 "y.tab.c"
    break;

  case 9:
#line 135 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-2].lv_integer) * (builtin_expr_parse_vsp[0].lv_integer); }
#line 1513 "y.tab.c"
    break;

  case 10:
#line 137 "cook/builtin/expr_parse.y"
        {
            if ((builtin_expr_parse_vsp[0].lv_integer) == 0)
            {
                builtin_expr_parse_error(i18n("division by zero"));
                (builtin_expr_parse_val.lv_integer) = 0;
            }
            else
                (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-2].lv_integer) / (builtin_expr_parse_vsp[0].lv_integer);
        }
#line 1527 "y.tab.c"
    break;

  case 11:
#line 147 "cook/builtin/expr_parse.y"
        {
            if ((builtin_expr_parse_vsp[0].lv_integer) == 0)
            {
                builtin_expr_parse_error(i18n("modulo by zero"));
                (builtin_expr_parse_val.lv_integer) = 0;
            }
            else
                (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-2].lv_integer) % (builtin_expr_parse_vsp[0].lv_integer);
        }
#line 1541 "y.tab.c"
    break;

  case 12:
#line 157 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-2].lv_integer) + (builtin_expr_parse_vsp[0].lv_integer); }
#line 1547 "y.tab.c"
    break;

  case 13:
#line 159 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-2].lv_integer) - (builtin_expr_parse_vsp[0].lv_integer); }
#line 1553 "y.tab.c"
    break;

  case 14:
#line 161 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-2].lv_integer) << (builtin_expr_parse_vsp[0].lv_integer); }
#line 1559 "y.tab.c"
    break;

  case 15:
#line 163 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = (builtin_expr_parse_vsp[-2].lv_integer) >> (builtin_expr_parse_vsp[0].lv_integer); }
#line 1565 "y.tab.c"
    break;

  case 16:
#line 165 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) < (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1571 "y.tab.c"
    break;

  case 17:
#line 167 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) <= (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1577 "y.tab.c"
    break;

  case 18:
#line 169 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) > (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1583 "y.tab.c"
    break;

  case 19:
#line 171 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) >= (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1589 "y.tab.c"
    break;

  case 20:
#line 173 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) == (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1595 "y.tab.c"
    break;

  case 21:
#line 175 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) != (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1601 "y.tab.c"
    break;

  case 22:
#line 177 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) & (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1607 "y.tab.c"
    break;

  case 23:
#line 179 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) ^ (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1613 "y.tab.c"
    break;

  case 24:
#line 181 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) | (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1619 "y.tab.c"
    break;

  case 25:
#line 183 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) && (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1625 "y.tab.c"
    break;

  case 26:
#line 185 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-2].lv_integer) || (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1631 "y.tab.c"
    break;

  case 27:
#line 187 "cook/builtin/expr_parse.y"
        { (builtin_expr_parse_val.lv_integer) = ((builtin_expr_parse_vsp[-4].lv_integer) ? (builtin_expr_parse_vsp[-2].lv_integer) : (builtin_expr_parse_vsp[0].lv_integer)); }
#line 1637 "y.tab.c"
    break;


#line 1641 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter builtin_expr_parse_char, and that requires
     that builtin_expr_parse_token be updated with the new translation.  We take the
     approach of translating immediately before every use of builtin_expr_parse_token.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     builtin_expr_parse_ABORT, builtin_expr_parse_ACCEPT, or builtin_expr_parse_ERROR immediately after altering builtin_expr_parse_char or
     if it invokes builtin_expr_parse_BACKUP.  In the case of builtin_expr_parse_ABORT or builtin_expr_parse_ACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of builtin_expr_parse_ERROR or builtin_expr_parse_BACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  builtin_expr_parse__SYMBOL_PRINT ("-> $$ =", builtin_expr_parse_r1[builtin_expr_parse_n], &builtin_expr_parse_val, &builtin_expr_parse_loc);

  builtin_expr_parse_POPSTACK (builtin_expr_parse_len);
  builtin_expr_parse_len = 0;
  builtin_expr_parse__STACK_PRINT (builtin_expr_parse_ss, builtin_expr_parse_ssp);

  *++builtin_expr_parse_vsp = builtin_expr_parse_val;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int builtin_expr_parse_lhs = builtin_expr_parse_r1[builtin_expr_parse_n] - builtin_expr_parse_NTOKENS;
    const int builtin_expr_parse_i = builtin_expr_parse_pgoto[builtin_expr_parse_lhs] + *builtin_expr_parse_ssp;
    builtin_expr_parse_state = (0 <= builtin_expr_parse_i && builtin_expr_parse_i <= builtin_expr_parse_LAST && builtin_expr_parse_check[builtin_expr_parse_i] == *builtin_expr_parse_ssp
               ? builtin_expr_parse_table[builtin_expr_parse_i]
               : builtin_expr_parse_defgoto[builtin_expr_parse_lhs]);
  }

  goto builtin_expr_parse_newstate;


/*--------------------------------------.
| builtin_expr_parse_errlab -- here on detecting error.  |
`--------------------------------------*/
builtin_expr_parse_errlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  builtin_expr_parse_token = builtin_expr_parse_char == builtin_expr_parse_EMPTY ? builtin_expr_parse_EMPTY : builtin_expr_parse_TRANSLATE (builtin_expr_parse_char);

  /* If not already recovering from an error, report this error.  */
  if (!builtin_expr_parse_errstatus)
    {
      ++builtin_expr_parse_nerrs;
#if ! builtin_expr_parse_ERROR_VERBOSE
      builtin_expr_parse_error (builtin_expr_parse__("syntax error"));
#else
# define builtin_expr_parse_SYNTAX_ERROR builtin_expr_parse_syntax_error (&builtin_expr_parse_msg_alloc, &builtin_expr_parse_msg, \
                                        builtin_expr_parse_ssp, builtin_expr_parse_token)
      {
        char const *builtin_expr_parse_msgp = builtin_expr_parse__("syntax error");
        int builtin_expr_parse_syntax_error_status;
        builtin_expr_parse_syntax_error_status = builtin_expr_parse_SYNTAX_ERROR;
        if (builtin_expr_parse_syntax_error_status == 0)
          builtin_expr_parse_msgp = builtin_expr_parse_msg;
        else if (builtin_expr_parse_syntax_error_status == 1)
          {
            if (builtin_expr_parse_msg != builtin_expr_parse_msgbuf)
              builtin_expr_parse_STACK_FREE (builtin_expr_parse_msg);
            builtin_expr_parse_msg = builtin_expr_parse__CAST (char *, builtin_expr_parse_STACK_ALLOC (builtin_expr_parse__CAST (builtin_expr_parse_SIZE_T, builtin_expr_parse_msg_alloc)));
            if (!builtin_expr_parse_msg)
              {
                builtin_expr_parse_msg = builtin_expr_parse_msgbuf;
                builtin_expr_parse_msg_alloc = sizeof builtin_expr_parse_msgbuf;
                builtin_expr_parse_syntax_error_status = 2;
              }
            else
              {
                builtin_expr_parse_syntax_error_status = builtin_expr_parse_SYNTAX_ERROR;
                builtin_expr_parse_msgp = builtin_expr_parse_msg;
              }
          }
        builtin_expr_parse_error (builtin_expr_parse_msgp);
        if (builtin_expr_parse_syntax_error_status == 2)
          goto builtin_expr_parse_exhaustedlab;
      }
# undef builtin_expr_parse_SYNTAX_ERROR
#endif
    }



  if (builtin_expr_parse_errstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (builtin_expr_parse_char <= builtin_expr_parse_EOF)
        {
          /* Return failure if at end of input.  */
          if (builtin_expr_parse_char == builtin_expr_parse_EOF)
            builtin_expr_parse_ABORT;
        }
      else
        {
          builtin_expr_parse_destruct ("Error: discarding",
                      builtin_expr_parse_token, &builtin_expr_parse_lval);
          builtin_expr_parse_char = builtin_expr_parse_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto builtin_expr_parse_errlab1;


/*---------------------------------------------------.
| builtin_expr_parse_errorlab -- error raised explicitly by builtin_expr_parse_ERROR.  |
`---------------------------------------------------*/
builtin_expr_parse_errorlab:
  /* Pacify compilers when the user code never invokes builtin_expr_parse_ERROR and the
     label builtin_expr_parse_errorlab therefore never appears in user code.  */
  if (0)
    builtin_expr_parse_ERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this builtin_expr_parse_ERROR.  */
  builtin_expr_parse_POPSTACK (builtin_expr_parse_len);
  builtin_expr_parse_len = 0;
  builtin_expr_parse__STACK_PRINT (builtin_expr_parse_ss, builtin_expr_parse_ssp);
  builtin_expr_parse_state = *builtin_expr_parse_ssp;
  goto builtin_expr_parse_errlab1;


/*-------------------------------------------------------------.
| builtin_expr_parse_errlab1 -- common code for both syntax error and builtin_expr_parse_ERROR.  |
`-------------------------------------------------------------*/
builtin_expr_parse_errlab1:
  builtin_expr_parse_errstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      builtin_expr_parse_n = builtin_expr_parse_pact[builtin_expr_parse_state];
      if (!builtin_expr_parse_pact_value_is_default (builtin_expr_parse_n))
        {
          builtin_expr_parse_n += builtin_expr_parse_TERROR;
          if (0 <= builtin_expr_parse_n && builtin_expr_parse_n <= builtin_expr_parse_LAST && builtin_expr_parse_check[builtin_expr_parse_n] == builtin_expr_parse_TERROR)
            {
              builtin_expr_parse_n = builtin_expr_parse_table[builtin_expr_parse_n];
              if (0 < builtin_expr_parse_n)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (builtin_expr_parse_ssp == builtin_expr_parse_ss)
        builtin_expr_parse_ABORT;


      builtin_expr_parse_destruct ("Error: popping",
                  builtin_expr_parse_stos[builtin_expr_parse_state], builtin_expr_parse_vsp);
      builtin_expr_parse_POPSTACK (1);
      builtin_expr_parse_state = *builtin_expr_parse_ssp;
      builtin_expr_parse__STACK_PRINT (builtin_expr_parse_ss, builtin_expr_parse_ssp);
    }

  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++builtin_expr_parse_vsp = builtin_expr_parse_lval;
  builtin_expr_parse__IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  builtin_expr_parse__SYMBOL_PRINT ("Shifting", builtin_expr_parse_stos[builtin_expr_parse_n], builtin_expr_parse_vsp, builtin_expr_parse_lsp);

  builtin_expr_parse_state = builtin_expr_parse_n;
  goto builtin_expr_parse_newstate;


/*-------------------------------------.
| builtin_expr_parse_acceptlab -- builtin_expr_parse_ACCEPT comes here.  |
`-------------------------------------*/
builtin_expr_parse_acceptlab:
  builtin_expr_parse_result = 0;
  goto builtin_expr_parse_return;


/*-----------------------------------.
| builtin_expr_parse_abortlab -- builtin_expr_parse_ABORT comes here.  |
`-----------------------------------*/
builtin_expr_parse_abortlab:
  builtin_expr_parse_result = 1;
  goto builtin_expr_parse_return;


#if !defined builtin_expr_parse_overflow || builtin_expr_parse_ERROR_VERBOSE
/*-------------------------------------------------.
| builtin_expr_parse_exhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
builtin_expr_parse_exhaustedlab:
  builtin_expr_parse_error (builtin_expr_parse__("memory exhausted"));
  builtin_expr_parse_result = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| builtin_expr_parse_return -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
builtin_expr_parse_return:
  if (builtin_expr_parse_char != builtin_expr_parse_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      builtin_expr_parse_token = builtin_expr_parse_TRANSLATE (builtin_expr_parse_char);
      builtin_expr_parse_destruct ("Cleanup: discarding lookahead",
                  builtin_expr_parse_token, &builtin_expr_parse_lval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this builtin_expr_parse_ABORT or builtin_expr_parse_ACCEPT.  */
  builtin_expr_parse_POPSTACK (builtin_expr_parse_len);
  builtin_expr_parse__STACK_PRINT (builtin_expr_parse_ss, builtin_expr_parse_ssp);
  while (builtin_expr_parse_ssp != builtin_expr_parse_ss)
    {
      builtin_expr_parse_destruct ("Cleanup: popping",
                  builtin_expr_parse_stos[*builtin_expr_parse_ssp], builtin_expr_parse_vsp);
      builtin_expr_parse_POPSTACK (1);
    }
#ifndef builtin_expr_parse_overflow
  if (builtin_expr_parse_ss != builtin_expr_parse_ssa)
    builtin_expr_parse_STACK_FREE (builtin_expr_parse_ss);
#endif
#if builtin_expr_parse_ERROR_VERBOSE
  if (builtin_expr_parse_msg != builtin_expr_parse_msgbuf)
    builtin_expr_parse_STACK_FREE (builtin_expr_parse_msg);
#endif
  return builtin_expr_parse_result;
}
